const Me            = imports.misc.extensionUtils.getCurrentExtension();
const Overview      = imports.ui.main.overview;
const ViewSelector  = imports.ui.main.overview._viewSelector;

const Apps  = Me.imports.apps;
const Prefs = Me.imports.prefs;

let applications = {};
let workspaces   = {};
let search       = {};
let undos        = [];

function init() {
    function toggle(page) {
        function toggle() {
            Overview.toggle();
            return Overview.visible;
        }
        return function() {
	        if (Overview.visible && ViewSelector._searchCancelled != page || toggle()) {
		        ViewSelector._searchCancelled = page;
                ViewSelector.reset();
		        page();
	        }
        };
    }

    workspaces = {
        toggle : toggle(function() {
	        ViewSelector._showPage(ViewSelector._workspacesPage);
        })
    };
    search = {
        toggle : toggle(function() {
            ViewSelector._searchResults.reset();
	        ViewSelector._showPage(ViewSelector._searchPage);
        })
    };
    applications = {
        toggle : toggle(function() {
	        ViewSelector._searchResults.doSearch(Apps.SEARCH_CATEGORY);
	        ViewSelector._showPage(ViewSelector._searchPage);
        })
    };
}

function enable() {
    let searchCancelled = ViewSelector._searchCancelled;
    undos.push(function() {
        ViewSelector._searchCancelled = searchCancelled;
        ViewSelector.reset();
    });

    undos.push(Prefs.connect(Overview, 'hiding', undos[0]));
    undos.push(Prefs.connect(ViewSelector._showAppsButton, 'notify::checked', undos[0]));
}

function disable() {
    while(undos.length > 0) {
        undos.pop()();
    }
}
